#!/usr/bin/python

import urllib, urllib2, urlparse, re
from BeautifulSoup import BeautifulStoneSoup
from xml.dom import minidom

class APIv3:
	# Class constants / default values.
	VERSION = 3
	DEFAULT_LIMIT = 10
	DEFAULT_OFFSET = 0
	LANG_SV = 'sv'
	LANG_EN = 'en'

	def __init__ (self, host, key):
		self.host = host
		self.apiKey = key
		self.username = None
		self.password = None
	
	def list (self):
		requestString = self.buildBaseString() + '/content?' + urllib.urlencode({'apikey': self.apiKey})
		requestString += self.buildParameterString(parameters);
		request = urllib2.Request(requestString)
		response = urllib2.urlopen(request)
		data = response.read()
		response.close()
		
		return self.parseResponse(data)
	
	def search (self, searchString, **keywordArguments):
		"""Performs a search and matches the supplied string against
		keywords, plot and other elements of each content node."""
		
		requestString = self.buildBaseString() + '/search/' + urllib.quote(searchString) + '?' + urllib.urlencode({'apikey': self.apiKey})
		requestString += self.buildParameterString(keywordArguments)
		print requestString
		request = urllib2.Request(requestString)
		response = urllib2.urlopen(request)
		data = response.read()
		response.close()
		return self.parseResponse(data)
	
	def stream (self, streamID, authmode, parameters = { }):
		requestString = self.buildBaseString() + '/player/plex/' + str(streamID) + '?' + urllib.urlencode({'apikey': self.apiKey, 'authmode': authmode})
		requestString += urllib.urlencode(parameters)
		#request = urllib2.Request(requestString)
		#response = urllib2.urlopen(request)
		#data = response.read()
		#response.close()
		
		return requestString
	
	def genre (self, parameters = { }):
		requestString = self.buildBaseString() + '/stream/' + str(streamID) + '?' + urllib.urlencode({'apikey': self.apiKeye})
		requestString += urllib.urlencode(parameters)
		request = urllib2.Request(requestString)
		response = urllib2.urlopen(request)
		data = response.read()
		response.close()
		
	def login (self, username, password):
		requestString = self.buildBaseString(True) + '/user/login'
		requestData = urllib.urlencode({ 'username': 'testuser', 'password': 'password' })
		request = urllib2.Request(requestString, requestData)
		response = urllib2.urlopen(request)
		responseData = response.read()
		response.close()
		
		print "string: " + requestString
		
		return self.parseResponse(responseData)
	
	def buildBaseString (self, secure = False):
		# If the user requests a secure host make sure that we use https.
		if secure == True:
				newHost = re.sub('^http:\/\/', 'https://', self.host, 1)
				return newHost + '/v' + str(self.__class__.VERSION)
		else:
			return self.host + '/v' + str(self.__class__.VERSION)
	
	def buildParameterString (self, parameters):
		parameterString = ''
		if len(parameters) > 0:
			parameterString += '&' + urllib.urlencode(parameters)
		
		return parameterString
	
	def parseResponse (self, response):
		"""Creates an XML parser instance and performs basic error checking
		before passing the entiere parser object back to the callee."""
		soup = BeautifulStoneSoup(response)
		return soup
	
	def purchase (self):
		
		return True

class APIv3v2:
	# Class constants / default values.
	VERSION = 3
	DEFAULT_LIMIT = 10
	DEFAULT_OFFSET = 0
	LANG_SV = 'sv'
	LANG_EN = 'en'

	def __init__ (self, host, key):
		self.host = host
		self.apiKey = key
		self.username = None
		self.password = None
	
	def list (self):
		requestString = self.buildBaseString() + '/content?' + urllib.urlencode({'apikey': self.apiKey})
		requestString += self.buildParameterString(parameters);
		request = urllib2.Request(requestString)
		response = urllib2.urlopen(request)
		data = response.read()
		response.close()
		
		return self.parseResponse(data)
	
	def search (self, searchString, **keywordArguments):
		"""Performs a search and matches the supplied string against
		keywords, plot and other elements of each content node."""
		
		requestString = self.buildBaseString() + '/search/' + urllib.quote(searchString) + '?' + urllib.urlencode({'apikey': self.apiKey})
		requestString += self.buildParameterString(keywordArguments)
		request = urllib2.Request(requestString)
		response = urllib2.urlopen(request)
		parser = minidom.parse(response)
		response.close()
		
		return self.parseResponse(data)
	
	def stream (self, streamID, authmode, parameters = { }):

		requestString = self.buildBaseString() + '/stream/' + str(streamID) + '?' + urllib.urlencode({'apikey': self.apiKey, 'authmode': authmode})
		requestString += urllib.urlencode(parameters)
		request = urllib2.Request(requestString)
		response = urllib2.urlopen(request)
		data = response.read()
		response.close()
		
		return self.parseResponse(data)
	
	def genre (self, parameters = { }):
		requestString = self.buildBaseString() + '/stream/' + str(streamID) + '?' + urllib.urlencode({'apikey': self.apiKeye})
		requestString += urllib.urlencode(parameters)
		request = urllib2.Request(requestString)
		response = urllib2.urlopen(request)
		data = response.read()
		response.close()
		
	def login (self, username, password):
		requestString = self.buildBaseString(True) + '/user/login'
		requestData = urllib.urlencode({ 'username': 'testuser', 'password': 'password' })
		request = urllib2.Request(requestString, requestData)
		response = urllib2.urlopen(request)
		responseData = response.read()
		response.close()
		
		print "string: " + requestString
		
		return self.parseResponse(responseData)
	
	def buildBaseString (self, secure = False):
		# If the user requests a secure host make sure that we use https.
		if secure == True:
				newHost = re.sub('^http:\/\/', 'https://', self.host, 1)
				return newHost + '/v' + str(self.__class__.VERSION)
		else:
			return self.host + '/v' + str(self.__class__.VERSION)
	
	def buildParameterString (self, parameters):
		parameterString = ''
		if len(parameters) > 0:
			parameterString += '&' + urllib.urlencode(parameters)
		
		return parameterString
	
